Index: trunk/src/org/openstreetmap/josm/io/FileImporter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/FileImporter.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/FileImporter.java	(revision 9231)
@@ -19,4 +19,8 @@
 import org.openstreetmap.josm.gui.util.GuiHelper;
 
+/**
+ * Abstract file importer.
+ * @since 1637
+ */
 public abstract class FileImporter implements Comparable<FileImporter>, LayerChangeListener {
 
@@ -77,5 +81,7 @@
 
     /**
-     * Wrapper to give meaningful output if things go wrong.
+     * Wrapper to {@link #importData(File, ProgressMonitor)} to give meaningful output if things go wrong.
+     * @param f data file to import
+     * @param progressMonitor progress monitor
      * @return true if data import was successful
      */
@@ -121,4 +127,10 @@
     }
 
+    /**
+     * Wrapper to {@link #importData(List, ProgressMonitor)} to give meaningful output if things go wrong.
+     * @param files data files to import
+     * @param progressMonitor progress monitor
+     * @return true if data import was successful
+     */
     public boolean importDataHandleExceptions(List<File> files, ProgressMonitor progressMonitor) {
         try {
Index: trunk/src/org/openstreetmap/josm/io/GpxExporter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/GpxExporter.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/GpxExporter.java	(revision 9231)
@@ -248,4 +248,16 @@
     /**
      * Add all those listeners to handle the enable state of the fields.
+     * @param data GPX data
+     * @param author Author checkbox
+     * @param authorName Author name textfield
+     * @param email E-mail textfield
+     * @param copyright Copyright textfield
+     * @param predefined Predefined button
+     * @param copyrightYear Copyright year textfield
+     * @param nameLabel Name label
+     * @param emailLabel E-mail label
+     * @param copyrightLabel Copyright label
+     * @param copyrightYearLabel Copyright year label
+     * @param warning Warning label
      */
     private static void addDependencies(
Index: trunk/src/org/openstreetmap/josm/io/GpxReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/GpxReader.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/GpxReader.java	(revision 9231)
@@ -499,4 +499,5 @@
         /**
          * convert url/urlname to link element (GPX 1.0 -&gt; GPX 1.1).
+         * @param attr attributes
          */
         private void convertUrlToLink(Map<String, Object> attr) {
@@ -509,5 +510,5 @@
                 GpxLink link = new GpxLink(url);
                 link.text = urlname;
-                @SuppressWarnings({ "unchecked", "rawtypes" })
+                @SuppressWarnings("unchecked")
                 Collection<GpxLink> links = (Collection<GpxLink>) attr.get(META_LINKS);
                 links.add(link);
@@ -531,5 +532,4 @@
      * @throws IOException if an IO error occurs, e.g. the input stream is closed.
      */
-    @SuppressWarnings("resource")
     public GpxReader(InputStream source) throws IOException {
         Reader utf8stream = UTFInputStreamReader.create(source);
Index: trunk/src/org/openstreetmap/josm/io/GpxWriter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/GpxWriter.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/GpxWriter.java	(revision 9231)
@@ -248,4 +248,6 @@
      * if content not null, open tag, write encoded content, and close tag
      * else do nothing.
+     * @param tag GPX tag
+     * @param content content
      */
     private void simpleTag(String tag, String content) {
@@ -260,4 +262,5 @@
     /**
      * output link
+     * @param link link
      */
     private void gpxLink(GpxLink link) {
@@ -272,4 +275,6 @@
     /**
      * output a point
+     * @param pnt waypoint
+     * @param mode {@code WAY_POINT} for {@code wpt}, {@code ROUTE_POINT} for {@code rtept}, {@code TRACK_POINT} for {@code trkpt}
      */
     private void wayPoint(WayPoint pnt, int mode) {
Index: trunk/src/org/openstreetmap/josm/io/MultiFetchServerObjectReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/MultiFetchServerObjectReader.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/MultiFetchServerObjectReader.java	(revision 9231)
@@ -299,4 +299,5 @@
      * @param type The primitive type. Must be one of {@link OsmPrimitiveType#NODE NODE}, {@link OsmPrimitiveType#WAY WAY},
      * {@link OsmPrimitiveType#RELATION RELATION}
+     * @param progressMonitor progress monitor
      * @throws OsmTransferException if an error occurs while communicating with the API server
      */
@@ -485,4 +486,5 @@
          * {@link OsmPrimitiveType#RELATION RELATION}
          * @param pkg the package of ids
+         * @param progressMonitor progress monitor
          * @return the {@link FetchResult} of this operation
          * @throws OsmTransferException if an error occurs while communicating with the API server
@@ -513,4 +515,5 @@
          * {@link OsmPrimitiveType#RELATION RELATION}
          * @param id the id
+         * @param progressMonitor progress monitor
          * @return the {@link DataSet} resulting of this operation
          * @throws OsmTransferException if an error occurs while communicating with the API server
@@ -544,4 +547,5 @@
          * {@link OsmPrimitiveType#RELATION RELATION}
          * @param pkg the set of ids
+         * @param progressMonitor progress monitor
          * @return the {@link FetchResult} of this operation
          * @throws OsmTransferException if an error occurs while communicating with the API server
Index: trunk/src/org/openstreetmap/josm/io/OsmReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmReader.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/OsmReader.java	(revision 9231)
@@ -57,5 +57,8 @@
     private static volatile List<OsmServerReadPostprocessor> postprocessors;
 
-    /** register a new postprocessor */
+    /** Register a new postprocessor.
+     * @param pp postprocessor
+     * @see #deregisterPostprocessor
+     */
     public static void registerPostprocessor(OsmServerReadPostprocessor pp) {
         if (postprocessors == null) {
@@ -65,5 +68,9 @@
     }
 
-    /** deregister a postprocessor previously registered with registerPostprocessor */
+    /**
+     * Deregister a postprocessor previously registered with {@link #registerPostprocessor}.
+     * @param pp postprocessor
+     * @see #registerPostprocessor
+     */
     public static void deregisterPostprocessor(OsmServerReadPostprocessor pp) {
         if (postprocessors != null) {
@@ -399,4 +406,5 @@
      * This is basically the same code as parseUnknown(), except for the warnings, which
      * are displayed for inner elements and not at top level.
+     * @param printWarning if {@code true}, a warning message will be printed if an unknown element is met
      * @throws XMLStreamException if there is an error processing the underlying XML source
      */
@@ -432,4 +440,5 @@
     /**
      * Read out the common attributes and put them into current OsmPrimitive.
+     * @param current primitive to update
      * @throws XMLStreamException if there is an error processing the underlying XML source
      */
Index: trunk/src/org/openstreetmap/josm/io/OsmServerBackreferenceReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmServerBackreferenceReader.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/OsmServerBackreferenceReader.java	(revision 9231)
@@ -148,4 +148,5 @@
      * Reads referring ways from the API server and replies them in a {@link DataSet}
      *
+     * @param progressMonitor progress monitor
      * @return the data set
      * @throws OsmTransferException if any error occurs during dialog with OSM API
Index: trunk/src/org/openstreetmap/josm/io/OsmServerHistoryReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmServerHistoryReader.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/OsmServerHistoryReader.java	(revision 9231)
@@ -50,4 +50,5 @@
     /**
      * Fetches the history from the OSM API and parses it
+     * @param progressMonitor progress monitor
      *
      * @return the data set with the parsed history data
Index: trunk/src/org/openstreetmap/josm/io/OsmServerWriter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmServerWriter.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/OsmServerWriter.java	(revision 9231)
@@ -256,4 +256,5 @@
     /**
      * Calls all registered upload postprocessors.
+     * @param pm progress monitor
      */
     public void executePostprocessors(ProgressMonitor pm) {
Index: trunk/src/org/openstreetmap/josm/io/OsmWriter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmWriter.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/OsmWriter.java	(revision 9231)
@@ -46,5 +46,8 @@
 
     /**
-     * Do not call this directly. Use OsmWriterFactory instead.
+     * Constructs a new {@code OsmWriter}.
+     * Do not call this directly. Use {@link OsmWriterFactory} instead.
+     * @param out print writer
+     * @param version OSM API version (0.6)
      */
     protected OsmWriter(PrintWriter out, boolean osmConform, String version) {
@@ -279,4 +282,6 @@
      * Add the common part as the form of the tag as well as the XML attributes
      * id, action, user, and visible.
+     * @param osm osm primitive
+     * @param tagname XML tag matching osm primitive (node, way, relation)
      */
     protected void addCommon(IPrimitive osm, String tagname) {
Index: trunk/src/org/openstreetmap/josm/io/UTFInputStreamReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/UTFInputStreamReader.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/UTFInputStreamReader.java	(revision 9231)
@@ -15,4 +15,5 @@
     /**
      * Creates a new {@link InputStreamReader} from the {@link InputStream} with UTF-8 as default encoding.
+     * @param input input stream
      * @return A reader with the correct encoding. Starts to read after the BOM.
      * @throws IOException if any I/O error occurs
@@ -25,4 +26,5 @@
     /**
      * Creates a new {@link InputStreamReader} from the {@link InputStream}.
+     * @param input input stream
      * @param defaultEncoding Used, when no BOM was recognized. Can be null.
      * @return A reader with the correct encoding. Starts to read after the BOM.
Index: trunk/src/org/openstreetmap/josm/io/XmlWriter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/XmlWriter.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/XmlWriter.java	(revision 9231)
@@ -17,4 +17,8 @@
     protected final PrintWriter out;
 
+    /**
+     * Constructs a new {@code XmlWriter}.
+     * @param out print writer
+     */
     public XmlWriter(PrintWriter out) {
         this.out = out;
@@ -30,4 +34,11 @@
     }
 
+    /**
+     * Encode the given string in XML1.0 format.
+     * Optimized to fast pass strings that don't need encoding (normal case).
+     *
+     * @param unencoded the unencoded input string
+     * @return XML1.0 string
+     */
     public static String encode(String unencoded) {
         return encode(unencoded, false);
Index: trunk/src/org/openstreetmap/josm/io/remotecontrol/AddTagsDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/remotecontrol/AddTagsDialog.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/remotecontrol/AddTagsDialog.java	(revision 9231)
@@ -119,4 +119,7 @@
     /**
      * Constructs a new {@code AddTagsDialog}.
+     * @param tags tags to add
+     * @param senderName String for skipping confirmations. Use empty string for always confirmed adding.
+     * @param primitives OSM objects that will be modified
      */
     public AddTagsDialog(String[][] tags, String senderName, Collection<? extends OsmPrimitive> primitives) {
@@ -260,4 +263,7 @@
      * parse addtags parameters Example URL (part):
      * addtags=wikipedia:de%3DResidenzschloss Dresden|name:en%3DDresden Castle
+     * @param args request arguments
+     * @param sender is a string for skipping confirmations. Use empty string for always confirmed adding.
+     * @param primitives OSM objects that will be modified
      */
     public static void addTags(final Map<String, String> args, final String sender, final Collection<? extends OsmPrimitive> primitives) {
Index: trunk/src/org/openstreetmap/josm/io/remotecontrol/RequestProcessor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/remotecontrol/RequestProcessor.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/remotecontrol/RequestProcessor.java	(revision 9231)
@@ -301,4 +301,6 @@
      * @param out
      *            The writer where the error is written
+     * @param help
+     *            Optional HTML help content to display, can be null
      * @throws IOException
      *             If the error can not be written
@@ -323,4 +325,6 @@
      * @param out
      *            The writer where the error is written
+     * @param help
+     *            Optional HTML help content to display, can be null
      * @throws IOException
      *             If the error can not be written
Index: trunk/src/org/openstreetmap/josm/io/remotecontrol/handler/AddWayHandler.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/remotecontrol/handler/AddWayHandler.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/remotecontrol/handler/AddWayHandler.java	(revision 9231)
@@ -122,8 +122,9 @@
      * Find the node with almost the same coords in dataset or in already added nodes
      * @param ll coordinates
+     * @param commands list of commands that will be modified if needed
      * @return node with almost the same coords
      * @since 5845
      */
-    Node findOrCreateNode(LatLon ll,  List<Command> commands) {
+    Node findOrCreateNode(LatLon ll, List<Command> commands) {
         Node nd = null;
 
Index: trunk/src/org/openstreetmap/josm/io/session/SessionReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/session/SessionReader.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/session/SessionReader.java	(revision 9231)
@@ -145,4 +145,5 @@
          * Add a task, e.g. a message dialog, that should
          * be executed in EDT after all layers have been added.
+         * @param task task to run in EDT
          */
         public void addPostLayersTask(Runnable task) {
Index: trunk/src/org/openstreetmap/josm/io/session/SessionWriter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/session/SessionWriter.java	(revision 9227)
+++ trunk/src/org/openstreetmap/josm/io/session/SessionWriter.java	(revision 9231)
@@ -65,4 +65,6 @@
      *
      * The exporter class must have a one-argument constructor with layerClass as formal parameter type.
+     * @param layerClass layer class
+     * @param exporter exporter for this layer class
      */
     public static void registerSessionLayerExporter(Class<? extends Layer> layerClass, Class<? extends SessionLayerExporter> exporter) {
@@ -95,4 +97,5 @@
      * @param active The index of active layer in {@code layers} (starts at 0). Ignored if set to -1
      * @param exporters The exporters to use to save layers
+     * @param dependencies layer dependencies
      * @param zip {@code true} if a joz archive has to be created, {@code false otherwise}
      * @since 6271