Index: trunk/src/org/openstreetmap/josm/data/projection/proj/AlbersEqualArea.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/projection/proj/AlbersEqualArea.java	(revision 9419)
+++ trunk/src/org/openstreetmap/josm/data/projection/proj/AlbersEqualArea.java	(revision 9426)
@@ -5,5 +5,4 @@
 
 import org.openstreetmap.josm.data.Bounds;
-
 import org.openstreetmap.josm.data.projection.ProjectionConfigurationException;
 
@@ -35,10 +34,12 @@
  * </ul>
  *
+ * @author Gerald I. Evenden (for original code in Proj4)
+ * @author Rueben Schulz
+ *
  * @see <A HREF="http://mathworld.wolfram.com/AlbersEqual-AreaConicProjection.html">Albers Equal-Area Conic Projection on MathWorld</A>
  * @see <A HREF="http://www.remotesensing.org/geotiff/proj_list/albers_equal_area_conic.html">"Albers_Conic_Equal_Area" on RemoteSensing.org</A>
  * @see <A HREF="http://srmwww.gov.bc.ca/gis/bceprojection.html">British Columbia Albers Standard Projection</A>
  *
- * @author Gerald I. Evenden (for original code in Proj4)
- * @author Rueben Schulz
+ * @since 9419
  */
 public class AlbersEqualArea extends AbstractProj {
@@ -164,5 +165,5 @@
         } else {
             x = 0.0;
-            y = n > 0.0 ? Math.PI/2.0 : - Math.PI/2.0;
+            y = n > 0.0 ? Math.PI/2.0 : -Math.PI/2.0;
         }
         return new double[] {y, x};
@@ -181,5 +182,5 @@
             return phi;
         }
-        for (int i=0; i<MAXIMUM_ITERATIONS; i++) {
+        for (int i = 0; i < MAXIMUM_ITERATIONS; i++) {
             final double sinpi = Math.sin(phi);
             final double cospi = Math.cos(phi);
Index: trunk/src/org/openstreetmap/josm/data/projection/proj/PolarStereographic.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/projection/proj/PolarStereographic.java	(revision 9419)
+++ trunk/src/org/openstreetmap/josm/data/projection/proj/PolarStereographic.java	(revision 9426)
@@ -14,18 +14,18 @@
  * (parameter lat_0).
  * <p>
- * 
+ *
  * In this file, only the polar case is implemented. This corresponds to
  * EPSG:9810 (Polar Stereographic Variant A) and EPSG:9829 (Polar Stereographic
  * Variant B).
  * <p>
- * 
+ *
  * It is required, that the latitude of natural origin has the value +/-90 degrees.
  * <p>
- * 
+ *
  * This class has been derived from the implementation of the Geotools project;
  * git 8cbf52d, org.geotools.referencing.operation.projection.PolarStereographic
  * at the time of migration.
  * <p>
- * 
+ *
  * <b>References:</b>
  * <ul>
@@ -44,4 +44,8 @@
  * </ul>
  *
+ * @author André Gosselin
+ * @author Martin Desruisseaux (PMO, IRD)
+ * @author Rueben Schulz
+ *
  * @see <A HREF="http://mathworld.wolfram.com/StereographicProjection.html">Stereographic projection on MathWorld</A>
  * @see <A HREF="http://www.remotesensing.org/geotiff/proj_list/polar_stereographic.html">Polar_Stereographic</A>
@@ -49,10 +53,7 @@
  * @see <A HREF="http://www.remotesensing.org/geotiff/proj_list/stereographic.html">Stereographic</A>
  * @see <A HREF="http://www.remotesensing.org/geotiff/proj_list/random_issues.html#stereographic">Some Random Stereographic Issues</A>
- * 
+ *
  * @see DoubleStereographic
- * 
- * @author André Gosselin
- * @author Martin Desruisseaux (PMO, IRD)
- * @author Rueben Schulz
+ * @since 9419
  */
 public class PolarStereographic extends AbstractProj implements IPolar {
@@ -88,10 +89,10 @@
      */
     boolean southPole;
-    
+
     @Override
     public String getName() {
         return tr("Polar Stereographic");
     }
-    
+
     @Override
     public String getProj4Id() {
@@ -128,5 +129,5 @@
         }
     }
-    
+
     @Override
     public double[] project(double y, double x) {
@@ -158,5 +159,5 @@
         final double halfe = e/2.0;
         double phi0 = 0;
-        for (int i=MAXIMUM_ITERATIONS;;) {
+        for (int i = MAXIMUM_ITERATIONS;;) {
             final double esinphi = e * Math.sin(phi0);
             final double phi = (Math.PI/2) - 2.0*Math.atan(t*Math.pow((1-esinphi)/(1+esinphi), halfe));