Index: trunk/test/unit/org/openstreetmap/josm/gui/conflict/tags/TagMergeItemTest.java
===================================================================
--- trunk/test/unit/org/openstreetmap/josm/gui/conflict/tags/TagMergeItemTest.java	(revision 9231)
+++ 	(revision )
@@ -1,165 +1,0 @@
-// License: GPL. For details, see LICENSE file.
-package org.openstreetmap.josm.gui.conflict.tags;
-
-import static org.junit.Assert.assertEquals;
-import static org.junit.Assert.assertNull;
-import static org.junit.Assert.fail;
-
-import org.junit.BeforeClass;
-import org.junit.Test;
-import org.openstreetmap.josm.JOSMFixture;
-import org.openstreetmap.josm.Main;
-import org.openstreetmap.josm.data.osm.Node;
-import org.openstreetmap.josm.gui.conflict.pair.MergeDecisionType;
-import org.openstreetmap.josm.gui.conflict.pair.tags.TagMergeItem;
-
-/**
- * Unit tests of {@link TagMergeItem} class.
- */
-public class TagMergeItemTest {
-
-    /**
-     * Setup test.
-     */
-    @BeforeClass
-    public static void init() {
-        JOSMFixture.createUnitTestFixture().init();
-    }
-
-    @Test
-    public void test_TagMergeItem() {
-        TagMergeItem item = new TagMergeItem("key", "myvalue", "theirvalue");
-        assertEquals("key", item.getKey());
-        assertEquals("myvalue", item.getMyTagValue());
-        assertEquals("theirvalue", item.getTheirTagValue());
-        assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-    }
-
-    @Test
-    public void test_TagMergeItem_2() {
-        Node n1 = new Node(1);
-        Node n2 = new Node(1);
-        n1.put("key", "myvalue");
-        n2.put("key", "theirvalue");
-
-        TagMergeItem item = new TagMergeItem("key", n1, n2);
-        assertEquals("key", item.getKey());
-        assertEquals("myvalue", item.getMyTagValue());
-        assertEquals("theirvalue", item.getTheirTagValue());
-        assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-    }
-
-    @Test
-    public void test_TagMergeItem_3() {
-        Node n1 = new Node(1);
-        Node n2 = new Node(1);
-        n1.put("key", "myvalue");
-        // n2 does not have this key
-
-        TagMergeItem item = new TagMergeItem("key", n1, n2);
-        assertEquals("key", item.getKey());
-        assertEquals("myvalue", item.getMyTagValue());
-        assertNull(item.getTheirTagValue());
-        assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-    }
-
-    @Test
-    public void test_TagMergeItem_4() {
-        Node n1 = new Node(1);
-        Node n2 = new Node(1);
-        // n1 does not have this key
-        // n1.put("key", "myvalue");
-        n2.put("key", "theirvalue");
-
-        TagMergeItem item = new TagMergeItem("key", n1, n2);
-        assertEquals("key", item.getKey());
-        assertNull(item.getMyTagValue());
-        assertEquals("theirvalue", item.getTheirTagValue());
-        assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-    }
-
-    @Test
-    public void test_decide() {
-        TagMergeItem item = new TagMergeItem("key", "myvalue", "theirvalue");
-        item.decide(MergeDecisionType.KEEP_MINE);
-        assertEquals(MergeDecisionType.KEEP_MINE, item.getMergeDecision());
-    }
-
-    @Test
-    public void test_decide_1() {
-        TagMergeItem item = new TagMergeItem("key", "myvalue", "theirvalue");
-        try {
-            item.decide(null);
-            fail("expected IllegalArgumentException not thrown");
-        } catch (IllegalArgumentException e) {
-            // OK
-            if (Main.isTraceEnabled()) {
-                Main.trace(e.getMessage());
-            }
-        }
-    }
-
-    @Test
-    public void test_applyToMyPrimitive() {
-        TagMergeItem item = new TagMergeItem("key", "myvalue", "theirvalue");
-        item.decide(MergeDecisionType.KEEP_MINE);
-
-        Node n1 = new Node(1);
-        n1.put("key", "oldvalue");
-        item.applyToMyPrimitive(n1);
-        assertEquals("myvalue", n1.get("key"));
-
-        n1 = new Node(1);
-        item.applyToMyPrimitive(n1);
-        assertEquals("myvalue", n1.get("key"));
-    }
-
-    @Test
-    public void test_applyToMyPrimitive_2() {
-        TagMergeItem item = new TagMergeItem("key", "myvalue", "theirvalue");
-        item.decide(MergeDecisionType.KEEP_THEIR);
-
-        Node n1 = new Node(1);
-        n1.put("key", "oldvalue");
-        item.applyToMyPrimitive(n1);
-        assertEquals("theirvalue", n1.get("key"));
-
-        n1 = new Node(1);
-        item.applyToMyPrimitive(n1);
-        assertEquals("theirvalue", n1.get("key"));
-    }
-
-    @Test
-    public void test_applyToMyPrimitive_3() {
-        TagMergeItem item = new TagMergeItem("key", "myvalue", "theirvalue");
-        // item is undecided
-        // item.decide(MergeDecisionType.KEEP_THEIR);
-
-        Node n1 = new Node(1);
-        n1.put("key", "oldvalue");
-        try {
-            item.applyToMyPrimitive(n1);
-            fail("expected IllegalStateException");
-        } catch (IllegalStateException e) {
-            // OK
-            if (Main.isTraceEnabled()) {
-                Main.trace(e.getMessage());
-            }
-        }
-    }
-
-    @Test
-    public void test_applyToMyPrimitive_4() {
-        TagMergeItem item = new TagMergeItem("key", "myvalue", "theirvalue");
-
-        try {
-            item.applyToMyPrimitive(null);
-            fail("expected IllegalArgumentException");
-        } catch (IllegalArgumentException e) {
-            // OK
-            if (Main.isTraceEnabled()) {
-                Main.trace(e.getMessage());
-            }
-        }
-    }
-}
Index: trunk/test/unit/org/openstreetmap/josm/gui/conflict/tags/TagMergeModelTest.java
===================================================================
--- trunk/test/unit/org/openstreetmap/josm/gui/conflict/tags/TagMergeModelTest.java	(revision 9231)
+++ 	(revision )
@@ -1,239 +1,0 @@
-// License: GPL. For details, see LICENSE file.
-package org.openstreetmap.josm.gui.conflict.tags;
-
-import static org.fest.reflect.core.Reflection.field;
-import static org.junit.Assert.assertEquals;
-import static org.junit.Assert.assertNull;
-
-import java.beans.PropertyChangeEvent;
-import java.beans.PropertyChangeListener;
-import java.util.List;
-import java.util.Set;
-
-import org.junit.BeforeClass;
-import org.junit.Test;
-import org.openstreetmap.josm.JOSMFixture;
-import org.openstreetmap.josm.data.osm.Node;
-import org.openstreetmap.josm.gui.conflict.pair.MergeDecisionType;
-import org.openstreetmap.josm.gui.conflict.pair.tags.TagMergeItem;
-import org.openstreetmap.josm.gui.conflict.pair.tags.TagMergeModel;
-
-/**
- * Unit tests of {@link TagMergeModel} class.
- */
-@SuppressWarnings("unchecked")
-public class TagMergeModelTest {
-
-    /**
-     * Setup test.
-     */
-    @BeforeClass
-    public static void init() {
-        JOSMFixture.createUnitTestFixture().init();
-    }
-
-    @Test
-    public void addPropertyChangeListener() {
-        TagMergeModel model = new TagMergeModel();
-        PropertyChangeListener listener = new PropertyChangeListener() {
-
-            public void propertyChange(PropertyChangeEvent evt) {
-            }
-        };
-        model.addPropertyChangeListener(listener);
-
-        Set<?> list = field("listeners").ofType(Set.class)
-        .in(model)
-        .get();
-
-        assertEquals(1, list.size());
-        assertEquals(listener, list.iterator().next());
-    }
-
-    @Test
-    public void removePropertyChangeListener() {
-        TagMergeModel model = new TagMergeModel();
-        PropertyChangeListener listener = new PropertyChangeListener() {
-
-            public void propertyChange(PropertyChangeEvent evt) {
-            }
-        };
-        model.addPropertyChangeListener(listener);
-        model.removePropertyChangeListener(listener);
-
-        Set<?> list = field("listeners")
-        .ofType(Set.class)
-        .in(model)
-        .get();
-
-        assertEquals(0, list.size());
-    }
-
-    @Test
-    public void populateNoConflichts() {
-        Node my = new Node(1);
-        Node their = new Node(1);
-        TagMergeModel model = new TagMergeModel();
-        model.populate(my, their);
-
-        List<TagMergeItem> list = field("tagMergeItems")
-        .ofType(List.class)
-        .in(model)
-        .get();
-
-        assertEquals(0, list.size());
-    }
-
-    @Test
-    public void populateNoConflicts1() {
-        Node my = new Node(1);
-        my.put("key", "value");
-        Node their = new Node(1);
-        their.put("key", "value");
-        TagMergeModel model = new TagMergeModel();
-        model.populate(my, their);
-
-        List<TagMergeItem> list = field("tagMergeItems")
-        .ofType(List.class)
-        .in(model)
-        .get();
-
-        assertEquals(0, list.size());
-    }
-
-    @Test
-    public void populateMissingKeyMine() {
-        Node my = new Node(1);
-        Node their = new Node(1);
-        their.put("key", "value");
-        TagMergeModel model = new TagMergeModel();
-        model.populate(my, their);
-
-        List<TagMergeItem> list = field("tagMergeItems")
-        .ofType(List.class)
-        .in(model)
-        .get();
-
-        assertEquals(1, list.size());
-        TagMergeItem item = list.get(0);
-        assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-        assertEquals("key", item.getKey());
-        assertNull(item.getMyTagValue());
-        assertEquals("value", item.getTheirTagValue());
-    }
-
-    @Test
-    public void populateMissingKeyTheir() {
-        Node my = new Node(1);
-        my.put("key", "value");
-        Node their = new Node(1);
-        TagMergeModel model = new TagMergeModel();
-        model.populate(my, their);
-
-        List<TagMergeItem> list = field("tagMergeItems")
-        .ofType(List.class)
-        .in(model)
-        .get();
-
-        assertEquals(1, list.size());
-        TagMergeItem item = list.get(0);
-        assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-        assertEquals("key", item.getKey());
-        assertNull(item.getTheirTagValue());
-        assertEquals("value", item.getMyTagValue());
-    }
-
-    @Test
-    public void populateConflictingValues() {
-        Node my = new Node(1);
-        my.put("key", "myvalue");
-        Node their = new Node(1);
-        their.put("key", "theirvalue");
-        TagMergeModel model = new TagMergeModel();
-        model.populate(my, their);
-
-        List<TagMergeItem> list = field("tagMergeItems")
-        .ofType(List.class)
-        .in(model)
-        .get();
-
-        assertEquals(1, list.size());
-        TagMergeItem item = list.get(0);
-        assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-        assertEquals("key", item.getKey());
-        assertEquals("myvalue", item.getMyTagValue());
-        assertEquals("theirvalue", item.getTheirTagValue());
-    }
-
-    @Test
-    public void addItem() {
-        TagMergeItem item = new TagMergeItem("key", "myvalue", "theirvalue");
-        TagMergeModel model = new TagMergeModel();
-        model.addItem(item);
-
-        List<TagMergeItem> list = field("tagMergeItems")
-        .ofType(List.class)
-        .in(model)
-        .get();
-
-        assertEquals(1, list.size());
-        item = list.get(0);
-        assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-        assertEquals("key", item.getKey());
-        assertEquals("myvalue", item.getMyTagValue());
-        assertEquals("theirvalue", item.getTheirTagValue());
-    }
-
-    @Test
-    public void decide() {
-        TagMergeItem item = new TagMergeItem("key", "myvalue", "theirvalue");
-        TagMergeModel model = new TagMergeModel();
-        model.addItem(item);
-
-        List<TagMergeItem> list = field("tagMergeItems")
-        .ofType(List.class)
-        .in(model)
-        .get();
-
-        model.decide(0, MergeDecisionType.KEEP_MINE);
-        assertEquals(1, list.size());
-        item = list.get(0);
-        assertEquals(MergeDecisionType.KEEP_MINE, item.getMergeDecision());
-
-        model.decide(0, MergeDecisionType.KEEP_THEIR);
-        assertEquals(1, list.size());
-        item = list.get(0);
-        assertEquals(MergeDecisionType.KEEP_THEIR, item.getMergeDecision());
-
-        model.decide(0, MergeDecisionType.UNDECIDED);
-        assertEquals(1, list.size());
-        item = list.get(0);
-        assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-    }
-
-    @Test
-    public void decideMultiple() {
-
-        TagMergeModel model = new TagMergeModel();
-        for (int i = 0; i < 10; i++) {
-            model.addItem(new TagMergeItem("key-" + i, "myvalue-" + i, "theirvalue-" +i));
-        }
-
-        List<TagMergeItem> list = field("tagMergeItems")
-        .ofType(List.class)
-        .in(model)
-        .get();
-
-        assertEquals(10, list.size());
-
-        model.decide(new int[] {0, 3, 5}, MergeDecisionType.KEEP_MINE);
-        for (int i = 0; i < 10; i++) {
-            TagMergeItem item = list.get(i);
-            if (i == 0 || i == 3 || i == 5) {
-                assertEquals(MergeDecisionType.KEEP_MINE, item.getMergeDecision());
-            } else {
-                assertEquals(MergeDecisionType.UNDECIDED, item.getMergeDecision());
-            }
-        }
-    }
-}