Index: trunk/src/org/openstreetmap/josm/data/projection/proj/DoubleStereographic.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/projection/proj/DoubleStereographic.java	(revision 9970)
+++ trunk/src/org/openstreetmap/josm/data/projection/proj/DoubleStereographic.java	(revision 9974)
@@ -35,5 +35,5 @@
     private double c;
     private double chi0;
-    private double R;
+    private double r;
 
     private static final double EPSILON = 1e-12;
@@ -61,5 +61,5 @@
         double phi0 = toRadians(lat_0);
         double e2 = ellps.e2;
-        R = sqrt(1-e2) / (1 - e2*pow(sin(phi0), 2));
+        r = sqrt(1-e2) / (1 - e2*pow(sin(phi0), 2));
         n = sqrt(1 + ellps.eb2 * pow(cos(phi0), 4));
         double S1 = (1 + sin(phi0)) / (1 - sin(phi0));
@@ -80,6 +80,6 @@
         double chi = asin((w - 1) / (w + 1));
         double B = 1 + sin(chi) * sin(chi0) + cos(chi) * cos(chi0) * cos(Lambda);
-        double x = 2 * R * cos(chi) * sin(Lambda) / B;
-        double y = 2 * R * (sin(chi) * cos(chi0) - cos(chi) * sin(chi0) * cos(Lambda)) / B;
+        double x = 2 * r * cos(chi) * sin(Lambda) / B;
+        double y = 2 * r * (sin(chi) * cos(chi0) - cos(chi) * sin(chi0) * cos(Lambda)) / B;
         return new double[] {x, y};
     }
@@ -88,9 +88,9 @@
     public double[] invproject(double x, double y) {
         double e2 = ellps.e2;
-        double g = 2 * R * tan(PI/4 - chi0/2);
-        double h = 4 * R * tan(chi0) + g;
+        double g = 2 * r * tan(PI/4 - chi0/2);
+        double h = 4 * r * tan(chi0) + g;
         double i = atan(x/(h + y));
         double j = atan(x/(g - y)) - i;
-        double chi = chi0 + 2 * atan((y - x * tan(j/2)) / (2 * R));
+        double chi = chi0 + 2 * atan((y - x * tan(j/2)) / (2 * r));
         double Lambda = j + 2*i;
         double lambda = Lambda / n;
Index: trunk/src/org/openstreetmap/josm/data/projection/proj/LambertAzimuthalEqualArea.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/projection/proj/LambertAzimuthalEqualArea.java	(revision 9970)
+++ trunk/src/org/openstreetmap/josm/data/projection/proj/LambertAzimuthalEqualArea.java	(revision 9974)
@@ -57,5 +57,5 @@
 
     /** Coefficients for authalic latitude. */
-    private double APA0, APA1, APA2;
+    private double aPA0, aPA1, aPA2;
 
     private double latitudeOfOrigin;
@@ -95,7 +95,7 @@
         final double es2 = e2 * e2;
         final double es3 = e2 * es2;
-        APA0 = P02 * es3 + P01 * es2 + P00 * e2;
-        APA1 = P11 * es3 + P10 * es2;
-        APA2 = P20 * es3;
+        aPA0 = P02 * es3 + P01 * es2 + P00 * e2;
+        aPA1 = P11 * es3 + P10 * es2;
+        aPA2 = P20 * es3;
 
         final double sinphi;
@@ -272,5 +272,5 @@
     private double authlat(final double beta) {
         final double t = beta + beta;
-        return beta + APA0 * Math.sin(t) + APA1 * Math.sin(t+t) + APA2 * Math.sin(t+t+t);
+        return beta + aPA0 * Math.sin(t) + aPA1 * Math.sin(t+t) + aPA2 * Math.sin(t+t+t);
     }
 
Index: trunk/src/org/openstreetmap/josm/data/projection/proj/ObliqueMercator.java
===================================================================
--- trunk/src/org/openstreetmap/josm/data/projection/proj/ObliqueMercator.java	(revision 9970)
+++ trunk/src/org/openstreetmap/josm/data/projection/proj/ObliqueMercator.java	(revision 9974)
@@ -159,16 +159,16 @@
      * Constants used in the transformation.
      */
-    private double B, A, E;
-
-    /**
-     * Convenience values equal to {@link #A} / {@link #B},
-     * {@link #A}&times;{@link #B}, and {@link #B} / {@link #A}.
-     */
-    private double ArB, AB, BrA;
+    private double b, a, e;
+
+    /**
+     * Convenience values equal to {@link #a} / {@link #b},
+     * {@link #a}&times;{@link #b}, and {@link #b} / {@link #a}.
+     */
+    private double arb, ab, bra;
 
     /**
      * <var>v</var> values when the input latitude is a pole.
      */
-    private double v_pole_n, v_pole_s;
+    private double vPoleN, vPoleS;
 
     /**
@@ -189,5 +189,5 @@
      * the oblique mercator case. The <var>v</var> value of the central point is 0.0.
      */
-    private double u_c;
+    private double uc;
 
     /**
@@ -227,18 +227,18 @@
         final double con = 1. - e2 * sinph0 * sinph0;
         double temp = cosph0 * cosph0;
-        B = Math.sqrt(1.0 + e2 * (temp * temp) / (1.0 - e2));
-        A = B * com / con;
-        final double D = B * com / (cosph0 * Math.sqrt(con));
-        double F = D * D - 1.0;
-        if (F < 0.0) {
-            F = 0.0;
+        b = Math.sqrt(1.0 + e2 * (temp * temp) / (1.0 - e2));
+        a = b * com / con;
+        final double d = b * com / (cosph0 * Math.sqrt(con));
+        double f = d * d - 1.0;
+        if (f < 0.0) {
+            f = 0.0;
         } else {
-            F = Math.sqrt(F);
+            f = Math.sqrt(f);
             if (latCenter < 0.0) {
-                F = -F;
-            }
-        }
-        E = F += D;
-        E = F * Math.pow(tsfn(latCenter, sinph0), B);
+                f = -f;
+            }
+        }
+        e = f += d;
+        e = f * Math.pow(tsfn(latCenter, sinph0), b);
 
         /*
@@ -276,10 +276,10 @@
              * The coefficients for the "two points" case.
              */
-            final double H = Math.pow(tsfn(lat1, Math.sin(lat1)), B);
-            final double L = Math.pow(tsfn(lat2, Math.sin(lat2)), B);
-            final double Fp = E / H;
-            final double P = (L - H) / (L + H);
-            double J = E * E;
-            J = (J - L * H) / (J + L * H);
+            final double h = Math.pow(tsfn(lat1, Math.sin(lat1)), b);
+            final double l = Math.pow(tsfn(lat2, Math.sin(lat2)), b);
+            final double fp = e / h;
+            final double p = (l - h) / (l + h);
+            double j = e * e;
+            j = (j - l * h) / (j + l * h);
             double diff = lon1 - lon2;
             if (diff < -Math.PI) {
@@ -289,8 +289,8 @@
             }
             centralMeridian = normalizeLonRad(0.5 * (lon1 + lon2) -
-                     Math.atan(J * Math.tan(0.5 * B * (lon1 - lon2)) / P) / B);
-            gamma0 = Math.atan(2.0 * Math.sin(B * normalizeLonRad(lon1 - centralMeridian)) /
-                     (Fp - 1.0 / Fp));
-            azimuth = Math.asin(D * Math.sin(gamma0));
+                     Math.atan(j * Math.tan(0.5 * b * (lon1 - lon2)) / p) / b);
+            gamma0 = Math.atan(2.0 * Math.sin(b * normalizeLonRad(lon1 - centralMeridian)) /
+                     (fp - 1.0 / fp));
+            azimuth = Math.asin(d * Math.sin(gamma0));
             rectifiedGridAngle = azimuth;
         } else {
@@ -315,7 +315,7 @@
                 rectifiedGridAngle = azimuth;
             }
-            gamma0 = Math.asin(Math.sin(azimuth) / D);
+            gamma0 = Math.asin(Math.sin(azimuth) / d);
             // Check for asin(+-1.00000001)
-            temp = 0.5 * (F - 1.0 / F) * Math.tan(gamma0);
+            temp = 0.5 * (f - 1.0 / f) * Math.tan(gamma0);
             if (Math.abs(temp) > 1.0) {
                 if (Math.abs(Math.abs(temp) - 1.0) > EPSILON) {
@@ -324,5 +324,5 @@
                 temp = (temp > 0) ? 1.0 : -1.0;
             }
-            centralMeridian = lonCenter - Math.asin(temp) / B;
+            centralMeridian = lonCenter - Math.asin(temp) / b;
         }
 
@@ -334,12 +334,12 @@
         sinrot    = Math.sin(rectifiedGridAngle);
         cosrot    = Math.cos(rectifiedGridAngle);
-        ArB       = A / B;
-        AB        = A * B;
-        BrA       = B / A;
-        v_pole_n  = ArB * Math.log(Math.tan(0.5 * (Math.PI/2.0 - gamma0)));
-        v_pole_s  = ArB * Math.log(Math.tan(0.5 * (Math.PI/2.0 + gamma0)));
+        arb       = a / b;
+        ab        = a * b;
+        bra       = b / a;
+        vPoleN  = arb * Math.log(Math.tan(0.5 * (Math.PI/2.0 - gamma0)));
+        vPoleS  = arb * Math.log(Math.tan(0.5 * (Math.PI/2.0 + gamma0)));
         boolean hotine = params.no_off != null && params.no_off;
         if (hotine) {
-            u_c = 0.0;
+            uc = 0.0;
         } else {
             if (Math.abs(Math.abs(azimuth) - Math.PI/2.0) < EPSILON_LATITUDE) {
@@ -348,11 +348,11 @@
                     throw new ProjectionConfigurationException("assertion error");
                 }
-                u_c = A * (lonCenter - centralMeridian);
+                uc = a * (lonCenter - centralMeridian);
             } else {
-                double u_c = Math.abs(ArB * Math.atan2(Math.sqrt(D * D - 1.0), Math.cos(azimuth)));
+                double uC = Math.abs(arb * Math.atan2(Math.sqrt(d * d - 1.0), Math.cos(azimuth)));
                 if (latCenter < 0.0) {
-                    u_c = -u_c;
+                    uC = -uC;
                 }
-                this.u_c = u_c;
+                this.uc = uC;
             }
         }
@@ -367,25 +367,25 @@
         double u, v;
         if (Math.abs(Math.abs(y) - Math.PI/2.0) > EPSILON) {
-            double Q = E / Math.pow(tsfn(y, Math.sin(y)), B);
-            double temp = 1.0 / Q;
-            double S = 0.5 * (Q - temp);
-            double V = Math.sin(B * x);
-            double U = (S * singamma0 - V * cosgamma0) / (0.5 * (Q + temp));
+            double q = e / Math.pow(tsfn(y, Math.sin(y)), b);
+            double temp = 1.0 / q;
+            double s = 0.5 * (q - temp);
+            double V = Math.sin(b * x);
+            double U = (s * singamma0 - V * cosgamma0) / (0.5 * (q + temp));
             if (Math.abs(Math.abs(U) - 1.0) < EPSILON) {
                 v = 0; // this is actually an error and should be reported to the caller somehow
             } else {
-                v = 0.5 * ArB * Math.log((1.0 - U) / (1.0 + U));
-            }
-            temp = Math.cos(B * x);
+                v = 0.5 * arb * Math.log((1.0 - U) / (1.0 + U));
+            }
+            temp = Math.cos(b * x);
             if (Math.abs(temp) < EPSILON_LATITUDE) {
-                u = AB * x;
+                u = ab * x;
             } else {
-                u = ArB * Math.atan2(S * cosgamma0 + V * singamma0, temp);
+                u = arb * Math.atan2(s * cosgamma0 + V * singamma0, temp);
             }
         } else {
-            v = y > 0 ? v_pole_n : v_pole_s;
-            u = ArB * y;
-        }
-        u -= u_c;
+            v = y > 0 ? vPoleN : vPoleS;
+            u = arb * y;
+        }
+        u -= uc;
         x = v * cosrot + u * sinrot;
         y = u * cosrot - v * sinrot;
@@ -396,17 +396,17 @@
     public double[] invproject(double x, double y) {
         double v = x * cosrot - y * sinrot;
-        double u = y * cosrot + x * sinrot + u_c;
-        double Qp = Math.exp(-BrA * v);
-        double temp = 1.0 / Qp;
-        double Sp = 0.5 * (Qp - temp);
-        double Vp = Math.sin(BrA * u);
-        double Up = (Vp * cosgamma0 + Sp * singamma0) / (0.5 * (Qp + temp));
-        if (Math.abs(Math.abs(Up) - 1.0) < EPSILON) {
+        double u = y * cosrot + x * sinrot + uc;
+        double qp = Math.exp(-bra * v);
+        double temp = 1.0 / qp;
+        double sp = 0.5 * (qp - temp);
+        double vp = Math.sin(bra * u);
+        double up = (vp * cosgamma0 + sp * singamma0) / (0.5 * (qp + temp));
+        if (Math.abs(Math.abs(up) - 1.0) < EPSILON) {
             x = 0.0;
-            y = Up < 0.0 ? -Math.PI / 2.0 : Math.PI / 2.0;
+            y = up < 0.0 ? -Math.PI / 2.0 : Math.PI / 2.0;
         } else {
-            y = Math.pow(E / Math.sqrt((1. + Up) / (1. - Up)), 1.0 / B);  //calculate t
+            y = Math.pow(e / Math.sqrt((1. + up) / (1. - up)), 1.0 / b);  //calculate t
             y = cphi2(y);
-            x = -Math.atan2(Sp * cosgamma0 - Vp * singamma0, Math.cos(BrA * u)) / B;
+            x = -Math.atan2(sp * cosgamma0 - vp * singamma0, Math.cos(bra * u)) / b;
         }
         return new double[] {y, x};