Index: trunk/images_nodist/presets/bicycle_road.svg
===================================================================
--- trunk/images_nodist/presets/bicycle_road.svg	(revision 10069)
+++ trunk/images_nodist/presets/bicycle_road.svg	(revision 10069)
@@ -0,0 +1,121 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Created with Inkscape (http://www.inkscape.org/) -->
+
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   version="1.0"
+   width="760"
+   height="760"
+   id="svg2"
+   inkscape:version="0.48.3.1 r9886"
+   sodipodi:docname="bicycle_road_sign_icon.svg">
+  <title
+     id="title3003">bicycle_road_sign_icon</title>
+  <metadata
+     id="metadata28">
+    <rdf:RDF>
+      <cc:Work
+         rdf:about="">
+        <dc:format>image/svg+xml</dc:format>
+        <dc:type
+           rdf:resource="http://purl.org/dc/dcmitype/StillImage" />
+        <dc:title>bicycle_road_sign_icon</dc:title>
+        <cc:license
+           rdf:resource="http://creativecommons.org/licenses/publicdomain/" />
+        <dc:creator>
+          <cc:Agent>
+            <dc:title>skyper</dc:title>
+          </cc:Agent>
+        </dc:creator>
+      </cc:Work>
+      <cc:License
+         rdf:about="http://creativecommons.org/licenses/publicdomain/">
+        <cc:permits
+           rdf:resource="http://creativecommons.org/ns#Reproduction" />
+        <cc:permits
+           rdf:resource="http://creativecommons.org/ns#Distribution" />
+        <cc:permits
+           rdf:resource="http://creativecommons.org/ns#DerivativeWorks" />
+      </cc:License>
+    </rdf:RDF>
+  </metadata>
+  <sodipodi:namedview
+     pagecolor="#ffffff"
+     bordercolor="#666666"
+     borderopacity="1"
+     objecttolerance="10"
+     gridtolerance="10"
+     guidetolerance="10"
+     inkscape:pageopacity="0"
+     inkscape:pageshadow="2"
+     inkscape:window-width="1920"
+     inkscape:window-height="1021"
+     id="namedview26"
+     showgrid="false"
+     inkscape:zoom="0.62105263"
+     inkscape:cx="-369.68442"
+     inkscape:cy="327.45704"
+     inkscape:window-x="0"
+     inkscape:window-y="27"
+     inkscape:window-maximized="1"
+     inkscape:current-layer="svg2" />
+  <defs
+     id="defs4" />
+  <path
+     inkscape:connector-curvature="0"
+     id="rect2841"
+     style="fill:#ffffff;fill-opacity:1;fill-rule:nonzero;stroke:#000000;stroke-width:2.01799999999999979;stroke-linecap:round;stroke-linejoin:round;stroke-miterlimit:4;stroke-opacity:0;stroke-dashoffset:0;opacity:1;stroke-dasharray:none"
+     d="m 45.824811,3.3417118 667.440239,0 c 17.26431,0 44.40426,25.3658182 44.40426,44.6040572 l 0,663.062641 c 0,17.56106 -26.23171,45.64977 -47.01218,45.64977 l -662.224403,0 c -16.898243,0 -44.6781525,-25.29652 -44.6781525,-37.91916 l 0,-672.469767 c 0,-19.094699 22.7368545,-42.9275412 42.0702365,-42.9275412 z" />
+  <path
+     inkscape:connector-curvature="0"
+     id="path1934"
+     style="fill:none;stroke:#000000;stroke-width:17;stroke-linecap:butt;stroke-linejoin:miter;stroke-miterlimit:4;stroke-opacity:1;stroke-dasharray:none;opacity:1"
+     d="m 25.443662,52.632534 0,658.329506 c 0,15.81111 15.542175,24.19269 27.474772,24.19269 l 657.360006,-0.25172 c 11.21703,0 24.66493,-13.41694 24.66493,-25.92349 l 0,-654.891497 c 0.17207,-19.416771 -15.69419,-29.40446 -26.88735,-29.40446 l -654.202941,0.25171 c -19.69216,0 -28.409417,14.141544 -28.409417,27.697261 z" />
+  <g
+     id="g3093"
+     transform="translate(-0.29929775,60.174376)">
+    <path
+       d="m 620.29687,319.82557 a 239.28563,239.28563 0 0 1 -478.57126,0 239.28563,239.28563 0 1 1 478.57126,0 z"
+       style="fill:#003399;fill-opacity:1;fill-rule:nonzero;stroke:none"
+       id="path1882"
+       inkscape:connector-curvature="0" />
+    <g
+       id="g12681">
+      <circle
+         cx="215"
+         cy="409"
+         r="161"
+         transform="matrix(0.404263,0,0,0.404263,177.6268,199.8607)"
+         style="fill:none;stroke:#ffffff;stroke-width:40px;stroke-opacity:1"
+         id="circle11777"
+         sodipodi:cx="215"
+         sodipodi:cy="409"
+         sodipodi:rx="161"
+         sodipodi:ry="161"
+         d="m 376,409 c 0,88.91784 -72.08216,161 -161,161 -88.91784,0 -161,-72.08216 -161,-161 0,-88.91784 72.08216,-161 161,-161 88.91784,0 161,72.08216 161,161 z" />
+      <circle
+         cx="790"
+         cy="406"
+         r="161"
+         transform="matrix(0.404263,0,0,0.404263,177.6268,199.8607)"
+         style="fill:none;stroke:#ffffff;stroke-width:40px;stroke-opacity:1"
+         id="circle11779"
+         sodipodi:cx="790"
+         sodipodi:cy="406"
+         sodipodi:rx="161"
+         sodipodi:ry="161"
+         d="m 951,406 c 0,88.91784 -72.08216,161 -161,161 -88.91784,0 -161,-72.08216 -161,-161 0,-88.91784 72.08216,-161 161,-161 88.91784,0 161,72.08216 161,161 z" />
+      <path
+         d="m 351.25144,206.11348 c -53.59172,0.52234 -44.50307,-5.53676 -73.33604,87.12573 -23.48869,74.03725 -20.93021,65.96322 -21.05305,71.15653 -0.0861,4.03463 3.17077,7.23353 7.26337,7.50734 8.51119,-0.86058 4.93119,0.9205 34.43938,-90.71243 107.82185,113.74166 67.3698,95.29738 125.39558,97.60727 76.26112,-0.73127 82.45951,3.96976 83.3649,-7.20825 -0.10447,-3.79564 -1.88041,-6.0591 -54.21853,-122.54013 l 5.01443,-13.78968 17.2371,-0.3134 -0.6268,-14.41649 -64.24739,0 c -5.67605,7.7654 2.29829,7.73058 31.02679,14.10308 l -5.01443,14.10309 -128.18137,0.3134 c 8.63597,-30.15622 3.76082,-28.27581 42.62266,-28.20617 l 0.3134,-14.72989 z m -46.63991,58.39296 125.428,-0.22238 -36.24958,97.40685 -89.17842,-97.18447 z m 140.55052,5.78215 -35.58241,93.40383 77.83652,0.22239 -42.25411,-93.62622 z"
+         style="fill:#ffffff;fill-rule:evenodd;stroke:#ffffff;stroke-opacity:1"
+         id="path11781"
+         inkscape:connector-curvature="0" />
+    </g>
+  </g>
+</svg>