Index: trunk/src/org/openstreetmap/josm/gui/MapView.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/MapView.java	(revision 10274)
+++ trunk/src/org/openstreetmap/josm/gui/MapView.java	(revision 10277)
@@ -95,5 +95,6 @@
      * Interface to notify listeners of a layer change.
      * <p>
-     * To be removed: end of 2016. Use {@link org.openstreetmap.josm.gui.layer.LayerManager.LayerChangeListener} instead.
+     * To be removed: end of 2016.
+     * @deprecated Use {@link org.openstreetmap.josm.gui.layer.LayerManager.LayerChangeListener} instead.
      * @author imi
      */
@@ -124,5 +125,6 @@
      * An interface that needs to be implemented in order to listen for changes to the active edit layer.
      * <p>
-     * To be removed: end of 2016. Use {@link ActiveLayerChangeListener} instead.
+     * To be removed: end of 2016.
+     * @deprecated Use {@link ActiveLayerChangeListener} instead.
      */
     @Deprecated
@@ -319,7 +321,8 @@
      * Removes a layer change listener
      * <p>
-     * You should register the listener on {@link Main#getLayerManager()} instead. To be removed: end of 2016.
+     * To be removed: end of 2016.
      *
      * @param listener the listener. Ignored if null or not registered.
+     * @deprecated You should register the listener on {@link Main#getLayerManager()} instead.
      */
     @Deprecated
@@ -330,4 +333,7 @@
         } catch (IllegalArgumentException e) {
             // Ignored in old implementation
+            if (Main.isDebugEnabled()) {
+                Main.debug(e.getMessage());
+            }
         }
         try {
@@ -335,4 +341,7 @@
         } catch (IllegalArgumentException e) {
             // Ignored in old implementation
+            if (Main.isDebugEnabled()) {
+                Main.debug(e.getMessage());
+            }
         }
     }
@@ -341,7 +350,8 @@
      * Removes an edit layer change listener
      * <p>
-     * You should register the listener on {@link Main#getLayerManager()} instead. To be removed: end of 2016.
+     * To be removed: end of 2016.
      *
      * @param listener the listener. Ignored if null or not registered.
+     * @deprecated You should register the listener on {@link Main#getLayerManager()} instead.
      */
     @Deprecated
@@ -351,4 +361,7 @@
         } catch (IllegalArgumentException e) {
             // Ignored in old implementation
+            if (Main.isDebugEnabled()) {
+                Main.debug(e.getMessage());
+            }
         }
     }
@@ -357,7 +370,8 @@
      * Adds a layer change listener
      * <p>
-     * You should register the listener on {@link Main#getLayerManager()} instead. To be removed: end of 2016.
+     * To be removed: end of 2016.
      *
      * @param listener the listener. Ignored if null or already registered.
+     * @deprecated You should register the listener on {@link Main#getLayerManager()} instead.
      */
     @Deprecated
@@ -369,9 +383,10 @@
      * Adds a layer change listener
      * <p>
-     * You should register the listener on {@link Main#getLayerManager()} instead. To be removed: end of 2016.
+     * To be removed: end of 2016.
      *
      * @param listener the listener. Ignored if null or already registered.
      * @param initialFire fire an active-layer-changed-event right after adding
      * the listener in case there is a layer present (should be)
+     * @deprecated You should register the listener on {@link Main#getLayerManager()} instead.
      */
     @Deprecated
@@ -390,14 +405,16 @@
      * Adds an edit layer change listener
      * <p>
-     * You should register the listener on {@link Main#getLayerManager()} instead. To be removed: end of 2016.
+     * To be removed: end of 2016.
      *
      * @param listener the listener. Ignored if null or already registered.
      * @param initialFire fire an edit-layer-changed-event right after adding
      * the listener in case there is an edit layer present
+     * @deprecated You should register the listener on {@link Main#getLayerManager()} instead.
      */
     @Deprecated
     public static void addEditLayerChangeListener(EditLayerChangeListener listener, boolean initialFire) {
         if (listener != null) {
-            Main.getLayerManager().addActiveLayerChangeListener(new EditLayerChangeAdapter(listener), initialFire && Main.isDisplayingMapView() && Main.map.mapView.getEditLayer() != null);
+            Main.getLayerManager().addActiveLayerChangeListener(new EditLayerChangeAdapter(listener),
+                    initialFire && Main.isDisplayingMapView() && Main.map.mapView.getEditLayer() != null);
         }
     }
@@ -406,7 +423,8 @@
      * Adds an edit layer change listener
      * <p>
-     * You should register the listener on {@link Main#getLayerManager()} instead. To be removed: end of 2016.
+     * To be removed: end of 2016.
      *
      * @param listener the listener. Ignored if null or already registered.
+     * @deprecated You should register the listener on {@link Main#getLayerManager()} instead.
      */
     @Deprecated
@@ -545,6 +563,7 @@
      * Add a layer to the current MapView.
      * <p>
-     * Use {@link Main#getLayerManager()}.addLayer() instead. To be removed: end of 2016.
+     * To be removed: end of 2016.
      * @param layer The layer to add
+     * @deprecated Use {@link Main#getLayerManager()}.addLayer() instead.
      */
     @Deprecated
@@ -574,5 +593,6 @@
 
     /**
-     * Use {@link Main#getLayerManager()} instead. To be removed: end of 2016.
+     * Returns current data set. To be removed: end of 2016.
+     * @deprecated Use {@link Main#getLayerManager()} instead.
      */
     @Override
@@ -602,6 +622,5 @@
 
     /**
-     * Determines the next active data layer according to the following
-     * rules:
+     * Determines the next active data layer according to the following rules:
      * <ul>
      *   <li>if there is at least one {@link OsmDataLayer} the first one
@@ -609,8 +628,9 @@
      *   <li>otherwise, the top most layer of any type becomes active</li>
      * </ul>
-     * To be removed: end of 2016 (now handled by {@link LayerManagerWithActive}
+     * To be removed: end of 2016.
      * @param layersList lit of layers
      *
      * @return the next active data layer
+     * @deprecated now handled by {@link LayerManagerWithActive}
      */
     @Deprecated
@@ -634,6 +654,7 @@
      * an LayerChange event is fired.
      * <p>
-     * Use {@link Main#getLayerManager()}.removeLayer() instead. To be removed: end of 2016.
+     * To be removed: end of 2016.
      * @param layer The layer to remove
+     * @deprecated Use {@link Main#getLayerManager()}.removeLayer() instead.
      */
     @Deprecated
@@ -696,8 +717,9 @@
      * Gets the index of the layer in the layer list.
      * <p>
-     * Access the layer list using {@link Main#getLayerManager()} instead. To be removed: end of 2016.
+     * To be removed: end of 2016.
      * @param layer The layer to search for.
      * @return The index in the list.
      * @throws IllegalArgumentException if that layer does not belong to this view.
+     * @deprecated Access the layer list using {@link Main#getLayerManager()} instead.
      */
     @Deprecated
@@ -919,7 +941,8 @@
 
     /**
-     * Use {@link LayerManager#getLayers()} instead. To be removed: end of 2016.
+     * Returns all layers. To be removed: end of 2016.
      *
      * @return An unmodifiable collection of all layers
+     * @deprecated Use {@link LayerManager#getLayers()} instead.
      */
     @Deprecated
@@ -929,7 +952,8 @@
 
     /**
-     * Use {@link LayerManager#getLayers()} instead. To be removed: end of 2016.
+     * Returns all layers as list. To be removed: end of 2016.
      *
      * @return An unmodifiable ordered list of all layers
+     * @deprecated Use {@link LayerManager#getLayers()} instead.
      */
     @Deprecated
@@ -945,5 +969,4 @@
      *     List&lt;WMSLayer&gt; wmsLayers = getLayersOfType(WMSLayer.class);
      * </pre>
-     * Use {@link LayerManager#getLayersOfType(Class)} instead.
      *
      * @param <T> layer type
@@ -951,4 +974,5 @@
      * @param ofType The layer type.
      * @return an unmodifiable list of layers of a certain type.
+     * @deprecated Use {@link LayerManager#getLayersOfType(Class)} instead.
      */
     @Deprecated
@@ -960,7 +984,7 @@
      * Replies the number of layers managed by this map view. To be removed: end of 2016.
      * <p>
-     * You can use {@link Main#getLayerManager()}.getLayers().size() instead.
      *
      * @return the number of layers managed by this map view
+     * @deprecated Use {@link Main#getLayerManager()}.getLayers().size() instead.
      */
     @Deprecated
@@ -972,7 +996,7 @@
      * Replies true if there is at least one layer in this map view
      * <p>
-     * You can use !{@link Main#getLayerManager()}.getLayers().isEmpty() instead.
      *
      * @return true if there is at least one layer in this map view
+     * @deprecated Use !{@link Main#getLayerManager()}.getLayers().isEmpty() instead.
      */
     @Deprecated
@@ -985,19 +1009,20 @@
      * of {@link OsmDataLayer} also sets editLayer to <code>layer</code>.
      * <p>
-     * You can use !{@link Main#getLayerManager()}.setActiveLayer() instead.
      *
      * @param layer the layer to be activate; must be one of the layers in the list of layers
      * @throws IllegalArgumentException if layer is not in the list of layers
+     * @deprecated Use !{@link Main#getLayerManager()}.setActiveLayer() instead.
      */
     @Deprecated
     public void setActiveLayer(Layer layer) {
-    	layerManager.setActiveLayer(layer);
-    }
+        layerManager.setActiveLayer(layer);
+    }
+
     /**
      * Replies the currently active layer
      * <p>
-     * You can use !{@link Main#getLayerManager()}.getActiveLayer() instead.
      *
      * @return the currently active layer (may be null)
+     * @deprecated Use !{@link Main#getLayerManager()}.getActiveLayer() instead.
      */
     @Deprecated
@@ -1034,7 +1059,7 @@
      * Replies the current edit layer, if any
      * <p>
-     * You can use !{@link Main#getLayerManager()}.getEditLayer() instead. To be made private: end of 2016.
      *
      * @return the current edit layer. May be null.
+     * @deprecated Use !{@link Main#getLayerManager()}.getEditLayer() instead. To be made private: end of 2016.
      */
     @Deprecated
@@ -1046,8 +1071,8 @@
      * replies true if the list of layers managed by this map view contain layer
      * <p>
-     * You can use !{@link Main#getLayerManager()}.containsLayer() instead.
      *
      * @param layer the layer
      * @return true if the list of layers managed by this map view contain layer
+     * @deprecated Use !{@link Main#getLayerManager()}.containsLayer() instead.
      */
     @Deprecated
Index: trunk/src/org/openstreetmap/josm/gui/layer/LayerManager.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/LayerManager.java	(revision 10274)
+++ trunk/src/org/openstreetmap/josm/gui/layer/LayerManager.java	(revision 10277)
@@ -15,5 +15,6 @@
  * This manager handles a list of layers with the first layer being the front layer.
  * <h1>Threading</h1>
- * Methods of this manager may be called from any thread in any order. Listeners are called while this layer manager is locked, so they should not block.
+ * Methods of this manager may be called from any thread in any order.
+ * Listeners are called while this layer manager is locked, so they should not block.
  *
  * @author Michael Zangl
Index: trunk/src/org/openstreetmap/josm/gui/layer/LayerManagerWithActive.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/layer/LayerManagerWithActive.java	(revision 10274)
+++ trunk/src/org/openstreetmap/josm/gui/layer/LayerManagerWithActive.java	(revision 10277)
@@ -34,5 +34,5 @@
          * @param e The change event.
          */
-        public void activeOrEditLayerChanged(ActiveLayerChangeEvent e);
+        void activeOrEditLayerChanged(ActiveLayerChangeEvent e);
     }
 
Index: trunk/src/org/openstreetmap/josm/gui/util/GuiHelper.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/util/GuiHelper.java	(revision 10274)
+++ trunk/src/org/openstreetmap/josm/gui/util/GuiHelper.java	(revision 10277)
@@ -134,5 +134,6 @@
      * <a href="http://docs.oracle.com/javase/tutorial/uiswing/concurrency/dispatch.html">Event Dispatch Thread</a>.
      * <p>
-     * Passes on the exception that was thrown to the thread calling this. The exception is wrapped in a {@link RuntimeException} if it was a normal {@link Throwable}.
+     * Passes on the exception that was thrown to the thread calling this.
+     * The exception is wrapped in a {@link RuntimeException} if it was a normal {@link Throwable}.
      * @param task The runnable to execute
      * @see SwingUtilities#invokeAndWait